/*
	CQ[()
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <time.h>

/*
#define TEST
*/

/* ^U */
#define FALSE	0	/* U */
#define TRUE	1	/* ^ */

/* Ղ̃TCY */
#define WIDTH	8	/*  */
#define HEIGHT	8	/*  */

/* D̎ */
#define TYPE_NONE	0	/* Ȃ */
#define TYPE_DESTROYER	1	/* 쒀 */
#define TYPE_CRUISER	2	/* m */
#define TYPE_BATTLESHIP	3	/*  */

/* ʒu */
#define POSX(pos)	((pos) % WIDTH)	/* XW𓾂 */
#define POSY(pos)	((pos) / WIDTH)	/* YW𓾂 */
#define POS(x, y)	((x) * WIDTH + (y))	/* ʒu𓾂 */

/* ^ */
typedef char	int8;	/* 8bit */
typedef unsigned char	uint8;	/* 8bitȂ */
typedef short	int16;	/* 16bit */
typedef unsigned short	uint16;	/* 16bitȂ */

/* D̏ */
struct Ship {
	uint8 type;	/*  */
	uint8 hp;	/* ϋv */
};

/* Q[̏ */
struct Game {
	struct Player {
		uint8 lv;	/* x */

		struct Ship ship[8];	/* D̏ */
		uint8 sea[WIDTH * HEIGHT];	/* Ղ̈ʒu */
		uint8 dist[WIDTH * HEIGHT];	/* e_ƑD̋ */

		uint8 under_attack[8];	/* U󂯂(vlp) */
		int8 poss[8][WIDTH * HEIGHT];	/* ʒu(vlp) */
		uint8 fired_pos;	/* ŌɍUꂽꏊ */
	} player[2];
};

/*
	ʒu͈̔͂`FbN
*/
int checkPos(int pos)
{
	int x = POSX(pos), y = POSY(pos);

	return 0 < pos && pos < WIDTH * HEIGHT && 1 <= x && x <= 6 && 1 <= y && y <= 6;
}

/*
	2_Ԃ̋𓾂
*/
int getPosDist(int pos1, int pos2)
{
	int dx, dy;

	if(!checkPos(pos1) || !checkPos(pos2))
		return 2;

	if(pos1 == pos2)
		return 0;

	if((dx = POSX(pos2) - POSX(pos1)) < 0)
		dx = -dx;
	if((dy = POSY(pos2) - POSY(pos1)) < 0)
		dy = -dy;
	return dx > dy ? dx: dy;
}

/*
	𓾂
*/
int getDist(uint8 *sea, int pos)
{
	/* ? */
	if(!checkPos(pos) || sea[pos])
		return 0;

	/* ߂? */
	if(sea[pos - WIDTH - 1] || sea[pos - WIDTH] || sea[pos - WIDTH + 1] || sea[pos - 1] || sea[pos + 1] || sea[pos + WIDTH - 1] || sea[pos + WIDTH] || sea[pos + WIDTH + 1])
		return 1;

	/*  */
	return 2;
}

/*
	D̈ʒu𓾂
*/
int getShipPos(struct Game *g, int player, int no)
{
	int pos;

	for(pos = 0; pos < WIDTH * HEIGHT; pos++)
		if(checkPos(pos) && no == g->player[player].sea[pos])
			return pos;

	return 0;
}

/*
	HP̏l𓾂 (put̉)
*/
static int getHp(uint8 type)
{
	if(type == TYPE_BATTLESHIP)
		return 3;
	else if(type == TYPE_CRUISER)
		return 2;
	else
		return 1;
}

/*
	zu
*/
int put(struct Player *p, int no, int type, int pos)
{
	if(!checkPos(pos) || p->sea[pos])
		return FALSE;

	p->sea[pos] = no;
	p->ship[no].type = type;
	p->ship[no].hp = getHp(type);
	return TRUE;
}

/*
	_ɔzu
*/
void putRand(struct Player *p, int no, int type)
{
	while(!put(p, no, type, rand() % (WIDTH * HEIGHT)))
		;
}

/*
	_[W^
*/
int damage(struct Player *p, int pos)
{
	int no;

	if(!checkPos(pos))
		return -1;
	if((no = p->sea[pos]) == 0)
		return -1;

	if(--p->ship[no].hp <= 0)
		p->sea[pos] = 0;
	return p->ship[no].hp;
}

/*
	Uł邩`FbN
*/
static int checkFire(struct Game *g, int player, int pos)
{
	struct Player *p = &g->player[player];

	if(!checkPos(pos))
		return FALSE;
	if(getDist(p->sea, pos) >= 2)
		return FALSE;
	return TRUE;
}

/*
	U
*/
int fire(struct Game *g, int player, int pos)
{
	struct Player *p = &g->player[player], *o = &g->player[!player];
	int i, j, d, no;

	/* Us\? */
	if(!checkFire(g, player, pos))
		return -1;

	o->fired_pos = pos;

	/* U */
	no = o->sea[pos];

	if((d = getDist(o->sea, pos)) == 0) {
		damage(o, pos);
		if(o->sea[pos] == 0) {
			o->under_attack[no] = FALSE;
			p->dist[pos] = 4;
		} else {
			o->under_attack[no] = TRUE;
			p->dist[pos] = d + 1;
		}
	} else {
		o->under_attack[no] = FALSE;
		p->dist[pos] = d + 1;
	}

	/* ʒuύX(̍Uɑ΂) */
	if(d == 0 && o->sea[pos] == 0) { /*  */
		for(i = 0; i < sizeof(o->ship) / sizeof(o->ship[0]); i++) {
			/* ̎͂̉\߂??? */
			if(p->poss[i][pos - WIDTH - 1] > 0)
				p->poss[i][pos - WIDTH - 1] = 0;
			if(p->poss[i][pos - WIDTH + 0] > 0)
				p->poss[i][pos - WIDTH + 0] = 0;
			if(p->poss[i][pos - WIDTH + 1] > 0)
				p->poss[i][pos - WIDTH + 1] = 0;
			if(p->poss[i][pos - 1] > 0)
				p->poss[i][pos - 1] = 0;
			if(p->poss[i][pos + 0] > 0)
				p->poss[i][pos + 0] = 0;
			if(p->poss[i][pos + 1] > 0)
				p->poss[i][pos + 1] = 0;
			if(p->poss[i][pos + WIDTH - 1] > 0)
				p->poss[i][pos + WIDTH - 1] = 0;
			if(p->poss[i][pos + WIDTH + 0] > 0)
				p->poss[i][pos + WIDTH + 0] = 0;
			if(p->poss[i][pos + WIDTH + 1] > 0)
				p->poss[i][pos + WIDTH + 1] = 0;
			/* ̏ꏊ݂̑??? */
			for(j = 0; j < WIDTH * HEIGHT; j++)
				if(p->poss[i][j] == 9)
					p->poss[i][j] = 0;
		}
		/* vꏊɑ̑D݂͑Ȃ */
		for(i = 0; i < sizeof(o->ship) / sizeof(o->ship[0]); i++)
			p->poss[i][pos] = -1;
		/* vD݂͑Ȃ */
		memset(p->poss[no], 0xff, WIDTH * HEIGHT);
	} else {
		for(i = 0; i < sizeof(o->ship) / sizeof(o->ship[0]); i++) {
			if(o->ship[i].hp > 0) {
				if(d == 0) { /*  */
					/* ̏ꏊ݂̑??? */
					for(j = 0; j < WIDTH * HEIGHT; j++)
						if(p->poss[i][j] == 9)
							p->poss[i][j] = 0;
					/* 쒀͈ȊO݂ */
					if(getHp(o->ship[i].type) > 1)
						p->poss[i][pos] = 9;
				} else if(d == 1) { /* ߂ */
					/* ̎͂ɑ݂\ */
					if(p->poss[i][pos - WIDTH - 1] == 0)
						p->poss[i][pos - WIDTH - 1] = 1;
					if(p->poss[i][pos - WIDTH + 0] == 0)
						p->poss[i][pos - WIDTH + 0] = 1;
					if(p->poss[i][pos - WIDTH + 1] == 0)
						p->poss[i][pos - WIDTH + 1] = 1;
					if(p->poss[i][pos - 1] == 0)
						p->poss[i][pos - 1] = 1;
					p->poss[i][pos + 0] = -1;
					if(p->poss[i][pos + 1] == 0)
						p->poss[i][pos + 1] = 1;
					if(p->poss[i][pos + WIDTH - 1] == 0)
						p->poss[i][pos + WIDTH - 1] = 1;
					if(p->poss[i][pos + WIDTH + 0] == 0)
						p->poss[i][pos + WIDTH + 0] = 1;
					if(p->poss[i][pos + WIDTH + 1] == 0)
						p->poss[i][pos + WIDTH + 1] = 1;
				} else { /*  */
					/* ̎͂ɂ݂͑Ȃ */
					p->poss[i][pos - WIDTH - 1] = -1;
					p->poss[i][pos - WIDTH + 0] = -1;
					p->poss[i][pos - WIDTH + 1] = -1;
					p->poss[i][pos - 1] = -1;
					p->poss[i][pos + 0] = -1;
					p->poss[i][pos + 1] = -1;
					p->poss[i][pos + WIDTH - 1] = -1;
					p->poss[i][pos + WIDTH + 0] = -1;
					p->poss[i][pos + WIDTH + 1] = -1;
				}
			}
		}
	}

	/* ݉\ʒuύX(̍Uɑ΂) */
	for(i = 0; i < sizeof(p->ship) / sizeof(p->ship[0]); i++) {
		/* U̎͂ɑ݂\ */
		if(o->poss[i][pos - WIDTH - 1] == 0)
			o->poss[i][pos - WIDTH - 1] = 1;
		if(o->poss[i][pos - WIDTH + 0] == 0)
			o->poss[i][pos - WIDTH + 0] = 1;
		if(o->poss[i][pos - WIDTH + 1] == 0)
			o->poss[i][pos - WIDTH + 1] = 1;
		if(o->poss[i][pos - 1] == 0)
			o->poss[i][pos - 1] = 1;
		if(o->poss[i][pos + 0] == 0)
			o->poss[i][pos + 0] = 1;
		if(o->poss[i][pos + 1] == 0)
			o->poss[i][pos + 1] = 1;
		if(o->poss[i][pos + WIDTH - 1] == 0)
			o->poss[i][pos + WIDTH - 1] = 1;
		if(o->poss[i][pos + WIDTH + 0] == 0)
			o->poss[i][pos + WIDTH + 0] = 1;
		if(o->poss[i][pos + WIDTH + 1] == 0)
			o->poss[i][pos + WIDTH + 1] = 1;
	}
	return d;
}

/*
	݉\ړ (movePoss̉)
*/
static void movePoss1(int8 *poss, int dir)
{
	int pos;

	if(dir > 0)
		for(pos = 0; pos < WIDTH * HEIGHT; pos++) {
			if(checkPos(pos)) {
				if(checkPos(pos + dir))
					poss[pos] = poss[pos + dir];
				else
					poss[pos] = -1;
			}
		}
	else
		for(pos = WIDTH * HEIGHT - 1; pos > 0; pos--) {
			if(checkPos(pos)) {
				if(checkPos(pos + dir))
					poss[pos] = poss[pos + dir];
				else
					poss[pos] = -1;
			}
		}
}

/*
	݉\ړ
*/
void movePoss(int8 *poss, int dir)
{
	int i;

	if(-WIDTH < dir && dir < WIDTH) {
		if(dir > 0)
			for(i = 0; i < dir; i++)
				movePoss1(poss, 1);
		else
			for(i = 0; i < -dir; i++)
				movePoss1(poss, -1);
	} else {
		if(dir > 0)
			for(i = 0; i < dir / 8; i++)
				movePoss1(poss, 8);
		else
			for(i = 0; i < -dir / 8; i++)
				movePoss1(poss, -8);
	}
}

void getMinMaxPoss(struct Game *g, int player, int pos, int r, int *min_poss, int *max_poss)
{
	struct Player *p = &g->player[player], *o = &g->player[!player];
	int no, i;

	if(min_poss != NULL)
		*min_poss = INT_MAX;
	if(max_poss != NULL)
		*max_poss = INT_MIN;

	for(no = 0; no < sizeof(p->poss) / sizeof(p->poss[0]); no++)
		for(i = 0; i < WIDTH * HEIGHT; i++)
			if(o->ship[no].hp > 0 && getPosDist(pos, i) <= r) {
				if(min_poss != NULL && *min_poss > p->poss[no][pos])
					*min_poss = p->poss[no][pos];
				if(max_poss != NULL && *max_poss < p->poss[no][pos])
					*max_poss = p->poss[no][pos];
			}
}

int getMaxPoss(struct Game *g, int player, int pos)
{
	int max_poss;

	getMinMaxPoss(g, player, pos, 0, NULL, &max_poss);
	return max_poss;
}

int getMaxPossArea(struct Game *g, int player, int pos)
{
	int max_poss;

	getMinMaxPoss(g, player, pos, 1, NULL, &max_poss);
	return max_poss;
}

/*
	ړł邩`FbN
*/
static int checkMove(struct Game *g, int player, int src, int dst)
{
	struct Player *p = &g->player[player], *o = &g->player[!player];

	if(!checkPos(src) || !p->sea[src])
		return FALSE;
	if(!checkPos(dst) || p->sea[dst])
		return FALSE;
	if(src == dst)
		return FALSE;
	if(POSX(dst) != POSX(src) && POSY(dst) != POSY(src))
		return FALSE;
	return TRUE;
}

/*
	ړ
*/
int move(struct Game *g, int player, int src, int dst)
{
	struct Player *p = &g->player[player], *o = &g->player[!player];
	int no;

	/* ړs\? */
	if(!checkMove(g, player, src, dst))
		return 0;

	/* ݉\ʒuύX */
	no = p->sea[src];
	movePoss(o->poss[no], src - dst);

	/* ړ */
	p->sea[dst] = no;
	p->sea[src] = 0;

	/* 쒀͈ȊOȂ΍UtO𗎂Ƃ */
	if(getHp(p->ship[p->sea[dst]].type) > 1)
		memset(p->under_attack, 0, sizeof(p->under_attack));

	return p->sea[dst];
}

int getEvalRun(struct Game *g, int player, int pos)
{
	int i, poss, eval = 0;

	if(getMaxPossArea(g, player, pos) < 0)
		return 256;

	for(i = 0; i < WIDTH * HEIGHT; i++)
		if(getPosDist(pos, i) <= 1) {
			if((poss = getMaxPoss(g, player, i)) < 0)
				eval += 2;
			else if(poss == 0)
				eval += 1;
			else if(poss == 1)
				eval += 0;
			else if(poss > 1)
				return 0;
		}

	return eval;
}

int thinkRun(struct Game *g, int player, int pos1, int *pos2)
{
	int pos, e, eval = getEvalRun(g, player, pos1);

	*pos2 = 0;

	for(pos = 0; pos < WIDTH * HEIGHT; pos++)
		if(checkMove(g, player, pos1, pos) && (e = getEvalRun(g, player, pos) + getPosDist(pos1, pos)) > eval) {
			eval = e;
			*pos2 = pos;
		}

	return *pos2 > 0;
}

int getEvalFire(struct Game *g, int player, int pos1)
{
	int poss, d;

	if(!checkFire(g, player, pos1))
		return 0;

	if(g->player[player].fired_pos > 0)
		d = getPosDist(g->player[player].fired_pos, pos1);
	else
		d = 0;

	if((poss = getMaxPoss(g, player, pos1)) > 1)
		return 1024;
	else if(poss == 1)
		return 256 + (d <= 2 ? 256: 0) + (rand() % 8);
	else if(poss == 0)
		return (d <= 2 ? 256: 0) + rand() % 8;
	else
		return 0;
}

int thinkFire(struct Game *g, int player, int *pos1)
{
	int pos, e, eval = 0;

	*pos1 = 0;

	for(pos = 0; pos < WIDTH * HEIGHT; pos++)
		if((e = getEvalFire(g, player, pos)) > eval) {
			eval = e;
			*pos1 = pos;
		}

	return *pos1 > 0;
}

int getEvalMove(struct Game *g, int player, int pos1, int pos2)
{
	struct Player *p = &g->player[player];
	int poss, hp, max_hp;

	if(!checkMove(g, player, pos1, pos2))
		return 0;

	hp = p->ship[p->sea[pos1]].hp;
	max_hp = getHp(p->ship[p->sea[pos1]].type);
	if(hp < max_hp && max_hp > 1)
		return 0;

	if((poss = getMaxPossArea(g, player, pos2)) > 1)
		return (32 - getPosDist(pos1, pos2)) * 256 + (rand() % 256);
	else if(poss == 1)
		return (24 - getPosDist(pos1, pos2)) * 256 + (rand() % 256);
	else if(poss == 0)
		return (16 - getPosDist(pos1, pos2)) * 256 + (rand() % 256);
	else
		return (8 - getPosDist(pos1, pos2)) * 256 + (rand() % 256);
}

int thinkMove(struct Game *g, int player, int *pos1, int *pos2)
{
	int p1, p2, e, eval = 0;

	*pos1 = *pos2 = 0;

	for(p1 = 0; p1 < WIDTH * HEIGHT; p1++)
		for(p2 = 0; p2 < WIDTH * HEIGHT; p2++)
			if((e = getEvalMove(g, player, p1, p2)) > eval) {
				eval = e;
				*pos1 = p1;
				*pos2 = p2;
			}

	return *pos1 > 0;
}

int thinkFireRand(struct Game *g, int player, int *pos1)
{
	int p1;

	*pos1 = 0;

	for(p1 = 0; p1 < WIDTH * HEIGHT; p1++)
		if(checkFire(g, player, p1))
			if(*pos1 == 0 || (rand() % 4) == 0)
				*pos1 = p1;

	return FALSE;
}

/*
	v[l
*/
int think(struct Game *g, int player, int *pos1, int *pos2)
{
	struct Player *p = &g->player[player];
	int pos;

	*pos1 = *pos2 = 0;

	/* G𔭌ꏊUł邩? */
	for(pos = 0; pos < WIDTH * HEIGHT; pos++)
		if(getMaxPoss(g, player, pos) > 1 && checkFire(g, player, pos)) {
#ifdef TEST
			printf("FIRE!\n");
#endif
			*pos1 = pos;
			return TRUE;
		}

	/* UĂ邩? */
	for(pos = 0; pos < WIDTH * HEIGHT; pos++)
		if(
		(p->sea[pos] && p->under_attack[p->sea[pos]]) ||
		(p->sea[pos] && p->ship[p->sea[pos]].hp < getHp(p->ship[p->sea[pos]].type))
		)
			if(thinkRun(g, player, pos, pos2)) {
#ifdef TEST
				printf("RUN\n");
#endif
				*pos1 = pos;
				return TRUE;
			}

	/* ߂ɓGꏊUł邩? */
	if(thinkFire(g, player, pos1)) {
#ifdef TEST
		printf("FIRE\n");
#endif
		return TRUE;
	}

	/* GȏꏊɈړ邩? */
	if(thinkMove(g, player, pos1, pos2))
		return TRUE;

	/* ͂_ɍU */
	return thinkFireRand(g, player, pos1);
}

/*
	v[l(_)
*/
int thinkRand(struct Game *g, int player, int *pos1, int *pos2)
{
	for(;;) {
		*pos1 = rand() % (WIDTH * HEIGHT);

		if((rand() % 30) == 0) {
			*pos2 = -1;
			if(checkFire(g, player, *pos1))
				return TRUE;
		} else {
			*pos2 = rand() % (WIDTH * HEIGHT);
			if(checkMove(g, player, *pos1, *pos2))
				return TRUE;
		}
	}
	return TRUE;
}

/*
	V{𓾂
*/
char getSymbol(int type)
{
	if(type == TYPE_BATTLESHIP)
		return 'B';
	else if(type == TYPE_CRUISER)
		return 'C';
	else if(type == TYPE_DESTROYER)
		return 'D';
	else
		return ' ';
}

/*
	D̖O𓾂
*/
const char *getName(int type)
{
	if(type == TYPE_BATTLESHIP)
		return "BattleShip";
	else if(type == TYPE_CRUISER)
		return "Cruiser";
	else if(type == TYPE_DESTROYER)
		return "Destroyer";
	else
		return "???";
}

/*
	V{\
*/
void dispSymbol(struct Game *g, int player, int pos)
{
	struct Player *p = &g->player[player], *o = &g->player[!player];
	int no = p->sea[pos], d = p->dist[pos], type;
	char buf[8] = "";

	if(no > 0)
		sprintf(buf, "%c", getSymbol(p->ship[no].type));

	if(d == 1)
		strcat(buf, "h");
	else if(d == 2)
		strcat(buf, "n");
	else if(d == 3)
		strcat(buf, "f");

	if(d == 4)
		strcat(buf, "#");
	else if(o->dist[pos] > 0)
		strcat(buf, "*");

	if(strcmp(buf, "") == 0)
		printf(".  ");
	else
		printf("%-3s", buf);
}

/*
	Q[̏Ԃ\
*/
void disp(struct Game *g, int player)
{
	struct Player *p = &g->player[player];
	int i;

	printf("    1   2   3   4   5   6\n");
	for(i = 1; i <= 6; i++) {
		printf("%d   ", i);
		dispSymbol(g, player, WIDTH * 1 + i);
		printf(" ");
		dispSymbol(g, player, WIDTH * 2 + i);
		printf(" ");
		dispSymbol(g, player, WIDTH * 3 + i);
		printf(" ");
		dispSymbol(g, player, WIDTH * 4 + i);
		printf(" ");
		dispSymbol(g, player, WIDTH * 5 + i);
		printf(" ");
		dispSymbol(g, player, WIDTH * 6 + i);
		printf("\n");
	}

#ifdef TEST
	for(i = 1; i <= 6; i++) {
		printf("%+d %+d %+d %+d %+d %+d  ", p->poss[1][WIDTH * 1 + i], p->poss[1][WIDTH * 2 + i], p->poss[1][WIDTH * 3 + i], p->poss[1][WIDTH * 4 + i], p->poss[1][WIDTH * 5 + i], p->poss[1][WIDTH * 6 + i]);
		printf("%+d %+d %+d %+d %+d %+d  ", p->poss[2][WIDTH * 1 + i], p->poss[2][WIDTH * 2 + i], p->poss[2][WIDTH * 3 + i], p->poss[2][WIDTH * 4 + i], p->poss[2][WIDTH * 5 + i], p->poss[2][WIDTH * 6 + i]);
		printf("%+d %+d %+d %+d %+d %+d", p->poss[3][WIDTH * 1 + i], p->poss[3][WIDTH * 2 + i], p->poss[3][WIDTH * 3 + i], p->poss[3][WIDTH * 4 + i], p->poss[3][WIDTH * 5 + i], p->poss[3][WIDTH * 6 + i]);
		printf("\n");
	}

	printf("UNDER ATTACK=%d,%d,%d\n", p->under_attack[1], p->under_attack[2], p->under_attack[3]);
#endif

	for(i = 1; i < 4; i++)
		printf("%d:%c(%d/%d)  ", i, getSymbol(p->ship[i].type), p->ship[i].hp, getHp(p->ship[i].type));
	printf("\n");
}

/*
	ʒu̓͂𓾂
*/
int input(int *pos1, int *pos2)
{
	int x, y;
	char buf[16];

	*pos1 = *pos2 = 0;
	memset(buf, 0, sizeof(buf));

	printf("?");
	fgets(buf, sizeof(buf), stdin);

	if(buf[0] == 0 || buf[1] == 0)
		return FALSE;

	x = buf[0] - '0';
	y = buf[1] - '0';
	*pos1 = POS(x, y);
	if(!checkPos(*pos1))
		return FALSE;
	if(buf[2] == '\n' || buf[2] == '\r' || buf[2] == 0)
		return TRUE;

	x = buf[2] - '0';
	y = buf[3] - '0';
	*pos2 = POS(x, y);
	return checkPos(*pos2);
}

/*
	v[
*/
int play(struct Game *g, int player)
{
	struct Player *p = &g->player[player], *o = &g->player[!player];
	int no, type, d, pos1, pos2;

	printf("** PLAYER %d **\n", player + 1);

	if(p->lv == 0) { /* l */
		disp(g, player);
redo1:;
#if 1
		while(!input(&pos1, &pos2))
			;
#else
		while(!thinkRand(g, player, &pos1, &pos2))
			;
#endif

		if(pos2 <= 0) { /* U */
			no = o->sea[pos1];
			type = o->ship[no].type;

			if((d = fire(g, 0, pos1)) == 0) {
				printf("FIRES AT (%d,%d) ... HIT!!\n", POSY(pos1), POSX(pos1));
				if(!o->sea[pos1])
					printf("SHIP%d(%s) SANK!!\n", no, getName(type));
			} else if(d == 1) {
				printf("FIRE AT (%d,%d) ... NEAR!\n", POSY(pos1), POSX(pos1));
			} else if(d == 2) {
				printf("FIRE AT (%d,%d) ... FAR\n", POSY(pos1), POSX(pos1));
			} else {
				printf("ERROR: OUT OF RANGE\n");
				goto redo1;
			}
		} else { /* ړ */
			no = p->sea[pos1];
			type = p->ship[no].type;

			if(move(g, player, pos1, pos2) > 0)
				printf("SHIP%d(%s) MOVES FROM (%d,%d) TO (%d,%d)\n", no, getName(type), POSY(pos1), POSY(pos1), POSY(pos2), POSX(pos2));
			else {
				printf("ERROR: OUT OF RANGE\n");
				goto redo1;
			}
		}
	} else { /* Rs[^ */
#ifdef TEST
		disp(g, player);
#else
		disp(g, !player);
#endif
redo2:;
		while(!think(g, player, &pos1, &pos2))
			;

		if(pos2 <= 0) { /* U */
			no = o->sea[pos1];
			type = o->ship[no].type;

			if((d = fire(g, player, pos1)) == 0) {
				printf("FIRED AT (%d,%d) ... SHIP%d(%s) ", POSY(pos1), POSX(pos1), no, getName(type));
				if(!o->sea[pos1])
					printf("SANK!!\n");
				else
					printf("DAMAGED!\n");
			} else if(d > 0)
				printf("FIRED AT (%d,%d) ... MISS\n", POSY(pos1), POSX(pos1));
			else
				goto redo2;
		} else { /* ړ */
			no = p->sea[pos1];
			type = p->ship[no].type;

			if(move(g, player, pos1, pos2) > 0) {
				if(POSX(pos1) == POSX(pos2)) {
					if(pos1 > pos2)
						printf("SHIP%d(%s) MOVED W%d\n", no, getName(type), POSY(pos1) - POSY(pos2));
					else
						printf("SHIP%d(%s) MOVED E%d\n", no, getName(type), POSY(pos2) - POSY(pos1));
				} else {
					if(pos1 > pos2)
						printf("SHIP%d(%s) MOVED N%d\n", no, getName(type), POSX(pos1) - POSX(pos2));
					else
						printf("SHIP%d(%s) MOVED S%d\n", no, getName(type), POSX(pos2) - POSX(pos1));
				}
			} else
				goto redo2;
		}
	}

	if(
	o->ship[0].hp == 0 &&
	o->ship[1].hp == 0 &&
	o->ship[2].hp == 0 &&
	o->ship[3].hp == 0 &&
	o->ship[4].hp == 0 &&
	o->ship[5].hp == 0 &&
	o->ship[6].hp == 0 &&
	o->ship[7].hp == 0
	) {
		printf("PLAYER %d WIN!\n", player + 1);
		return FALSE;
	}
	printf("\n");
	return TRUE;
}

int main(int argc, char *argv[])
{
	struct Game g;
	int no, pos, player = 0;

	printf(
	"**************\n"
	"* SEA BATTLE *\n"
	"**************\n"
	);

	srand(time(NULL));

	memset(&g, 0, sizeof(g));
	for(pos = 0; pos < WIDTH * HEIGHT; pos++)
		if(!checkPos(pos))
			g.player[0].poss[0][pos] = -1;
	memcpy(g.player[0].poss[1], g.player[0].poss[0], WIDTH * HEIGHT);
	memcpy(g.player[0].poss[2], g.player[0].poss[0], WIDTH * HEIGHT);
	memcpy(g.player[1].poss[0], g.player[0].poss[0], WIDTH * HEIGHT);
	memcpy(g.player[1].poss[1], g.player[0].poss[0], WIDTH * HEIGHT);
	memcpy(g.player[1].poss[2], g.player[0].poss[0], WIDTH * HEIGHT);

	g.player[0].lv = 0;
	putRand(&g.player[0], 1, TYPE_DESTROYER);
	putRand(&g.player[0], 2, TYPE_CRUISER);
	putRand(&g.player[0], 3, TYPE_BATTLESHIP);
	g.player[1].lv = 1;
	putRand(&g.player[1], 1, TYPE_DESTROYER);
	putRand(&g.player[1], 2, TYPE_CRUISER);
	putRand(&g.player[1], 3, TYPE_BATTLESHIP);

	while(play(&g, player))
		player = !player;
#ifdef TEST
#else
	getchar();
#endif
	return 0;
}

/* eof */